// MicrosoftOutlook script version 1.0

using LoginPI.Engine.ScriptBase;
using System.IO;

public class MicrosoftOutlook : ScriptBase
{
    private void Execute()
    {
        // This is a language dependent script. English is required.
    
        //Define environementvariables to use with Workload
        var temp = GetEnvironmentVariable("TEMP");
        RegImport(create_regfile(@"HKEY_CURRENT_USER\Software\Microsoft\Office\16.0\Common\General",@"ShownFirstRunOptin",@"dword:00000001"));

        // Download the PRF and PST file from the appliance through the KnownFiles method, if it already exists: Skip Download.
        if(!(FileExists($"{temp}\\LoginPI\\Outlook.prf")))
        {
            Log("Downloading File");
            CopyFile(KnownFiles.OutlookConfiguration, $"{temp}\\LoginPI\\Outlook.prf");
            CopyFile(KnownFiles.OutlookData, $"{temp}\\LoginPI\\Outlook.pst");
            
            // Looks for the %TEMP% string in the prf file and replaces it with the {temp} variable.
            File.WriteAllText($"{temp}\\LoginPI\\Outlook.prf", File.ReadAllText($"{temp}\\LoginPI\\Outlook.prf").Replace("%TEMP%", $"{temp}"));
        }
        else
        {
            Log("File already exists");
        }
            
        // Start Application
        START();
        MainWindow.Maximize();
        Wait(2);

        // Open the Inbox
        MainWindow.FindControl(className : "TreeItem:NetUIWBTreeDisplayNode", title : "*Inbox*",timeout:10).Click();
        Wait(3);

        // Scroll through E-mail
        MainWindow.Type("{DOWN}".Repeat(20),cpm:50);
        
        // Navigate to Calender
        MainWindow.FindControl(className : "Button:Navigation Module", title : "Calendar").Click();
        Wait(5);

        // Navigate to Contacts and open a contact
        MainWindow.FindControl(className : "Button:Navigation Module", title : "People").Click();
        Wait(5);
        MainWindow.Type("{DOWN}");
        MainWindow.Type("{Enter}");
        Wait(2);
        MainWindow.Type("{ESC}");

        // Navigate to Tasks
        MainWindow.Type("{CTRL+4}");
        Wait(3);

        STOP();

    }
    private string create_regfile(string key, string value, string data)
    {            
        System.Text.StringBuilder sb = new System.Text.StringBuilder();
        var file = System.IO.Path.Combine(System.IO.Path.GetTempPath(), "reg.reg");

        sb.AppendLine("Windows Registry Editor Version 5.00");
        sb.AppendLine();
        sb.AppendLine($"[{key}]");
        if(data.ToLower().Contains("dword"))
        {
            sb.AppendLine($"\"{value}\"={data.ToLower()}");
        }
        else
        {
            sb.AppendLine($"\"{value}\"=\"{data}\"");
        }
        sb.AppendLine();

        System.IO.File.WriteAllText(file, sb.ToString());

        return file;
    }
}